import processing.core.*; import java.applet.*; import java.awt.*; import java.awt.image.*; import java.awt.event.*; import java.io.*; import java.net.*; import java.text.*; import java.util.*; import java.util.zip.*; public class Myzel extends PApplet {/*
Mycelium
 By Ryan Alexander
 http://onecm.com/
 2005
 
 Adapted
 For Thomas Feuerstein
 http://feuerstein.myzel.net/
 By Peter Chiochetti
 http://arton.cunst.net/
 2006
 */

Mycelium myc;

int fc; // frame counter
float fd; // dim factor
int black;

PImage myFoodImg;
String SID; // cookie
String URI; // feed location

public void setup()
{
  size(768, 576, P3D);

  // connect to image feed
  // get session id
  SID = param("SID");
  URI = param("URI");
  if (URI == null)
    URI = "http://localhost/Myzel/feed.php";
  if (SID == null) {
    String[] SIDs = new String[1];
    SIDs = loadStrings(URI + "/SID");
    SID = SIDs[0];
  }
  println("Feed: " + URI + "?" + SID);

  // initialize mycel
  myFoodImg = loadImage("start.png");
  myc = new Mycelium(myFoodImg);
  for (int i = 0; i < 10; i++)
    myc.spore(random(width), random(height), (int)random(20, 50));

  fc = 1400;
  fd = 255.f/256.f;
  black = color (0,0,0);
  background(black);
  framerate(25);
}

public void draw()
{
  // every minute change image
  if (fc == 1500) {
    PImage img;
    print ("Load: ");
    img = loadImage(URI + "?" + SID);
    img.filter(OPAQUE);
    img.filter(GRAY);
    img.filter(BLUR);
    myFoodImg.copy(img, 0, 0, img.width, img.height, 0, 0, width, height);
    
    String[] NFO = new String[1];
    NFO = loadStrings(URI + "/NFO?" + SID);
    println(NFO[0]);
    status(NFO[0]);
    fc = 0;
  }
  // update display, dim image
  loadPixels();
  int l = pixels.length;
  for(int i=fc%25; i<l; i+=25)
      pixels[i] = blendC(black, pixels[i], fd);
  myc.display();
  updatePixels();
  fc ++;
}

//--------------------------------------------------------------------------------
class DParticle
{
  double x, y, xv, yv;
  int c;

  DParticle(double ix, double iy, double ixv, double iyv)
  {
    x = ix; y = iy;
    xv = ixv; yv = iyv;
  }

  public void update()
  {
    x += xv;
    y += yv;
  }

  public void update(double d)
  {
    xv *= d;
    yv *= d;
    x += xv;
    y += yv;
  }

  public void spring(double sx, double sy, double rest, double amount)
  {
    double dx = sx - x;
    double dy = sy - y;
    if(dx != 0 || dy != 0) {  // Prevent / by zero
      double mag = Math.sqrt(dx*dx + dy*dy);
      double ext = mag - rest;
      xv += (dx / mag * ext) * amount;
      yv += (dy / mag * ext) * amount;
    }
  }

  public void goal(double gx, double gy, double amount)
  {
    if(x != gx) xv += (gx - x) * amount;
    if(y != gy) yv += (gy - y) * amount;
  }
  
  public void avoid(double x, double y, double r, double amount)
  {
    if(touching(x, y, r)) spring(x, y, r, amount);
  }

  public void contain(double l, double t, double r, double b, double bouncy)
  {
    if(x < l) { x = l; xv *= -bouncy; }
    if(x > r) { x = r; xv *= -bouncy; }
    if(y < t) { y = t; yv *= -bouncy; }
    if(y > b) { y = b; yv *= -bouncy; }
  }
  
  public void containWrap(double l, double t, double r, double b)
  {
    if(x < l) { x = r+(x-l); }
    if(x > r) { x = l+(x-r); }
    if(y < t) { y = b+(y-t); }
    if(y > b) { y = t+(y-b); }
  }

  public boolean touching(double jx, double jy, double radii)
  {
    double dx = jx-x;
    double dy = jy-y;
    return dx*dx+dy*dy < radii*radii;
  }
}


//--------------------------------------------------------------------------------
class Particle
{
  float x, y, xv, yv;
  int c;

  Particle(float ix, float iy, float ixv, float iyv)
  {
    x = ix; y = iy;
    xv = ixv; yv = iyv;
  }

  public void update()
  {
    x += xv;
    y += yv;
  }

  public void update(float d)
  {
    xv *= d;
    yv *= d;
    x += xv;
    y += yv;
  }

  public void spring(float sx, float sy, float rest, float amount)
  {
    float dx = sx - x;
    float dy = sy - y;
    if(dx != 0 || dy != 0) {  // Prevent / by zero
      float mag = sqrt(dx*dx + dy*dy);
      float ext = mag - rest;
      xv += (dx / mag * ext) * amount;
      yv += (dy / mag * ext) * amount;
    }
  }
  
  public void spring(Particle p, float rest, float amount)
  {
    float dx = p.x - x;
    float dy = p.y - y;
    if(dx != 0 || dy != 0) {  // Prevent / by zero
      float mag = sqrt(dx*dx + dy*dy);
      float ext = mag - rest;
      xv += (dx / mag * ext) * amount;
      yv += (dy / mag * ext) * amount;
    }
  }

  public void goal(float gx, float gy, float amount)
  {
    if(x != gx) xv += (gx - x) * amount;
    if(y != gy) yv += (gy - y) * amount;
  }
  
  public void goal(float l, float t, float r, float b, float amount)
  {
    if(x < l) goal(l, y, amount);
    if(x > r) goal(r, y, amount);
    if(y < t) goal(x, t, amount);
    if(y > b) goal(x, b, amount);
  }
  
  public void avoid(float x, float y, float r, float amount)
  {
    if(touching(x, y, r)) spring(x, y, r, amount);
  }

  public void bounce(float hitx, float hity, float angle, float amount)
  {
    // Rotate a new vector to the angle
    float ax = cos(angle);
    float ay = sin(angle);
    float dotp = dot(xv, yv, ax, ay);

    xv = (ax * dotp - xv)*amount+ax;
    yv = (ay * dotp - yv)*amount+ay;

    x = hitx;
    y = hity;
  }

  public void contain(float l, float t, float r, float b, float bouncy)
  {
    if(x < l) { x = l; xv *= -bouncy; }
    if(x > r) { x = r; xv *= -bouncy; }
    if(y < t) { y = t; yv *= -bouncy; }
    if(y > b) { y = b; yv *= -bouncy; }
  }
  
  public void containWrap(float l, float t, float r, float b)
  {
    if(x < l) { x = r+(x-l); }
    if(x > r) { x = l+(x-r); }
    if(y < t) { y = b+(y-t); }
    if(y > b) { y = t+(y-b); }
  }

  public boolean touching(float jx, float jy, float radii)
  {
    float dx = jx-x;
    float dy = jy-y;
    return dx*dx+dy*dy < radii*radii;
  }
  
  public void copy(Particle p)
  {
    x = p.x; y = p.y;
    xv = p.xv; yv = p.yv;
    c = p.c;
  }
}


//--------------------------------------------------------------------------------
class DVector2
{
  double x, y;
  
  DVector2(double ix, double iy)
  {
    x = ix; y = iy;
  }
}


//--------------------------------------------------------------------------------
// Helpers
public float rotatedX(float v,float angle) { return v*cos(angle); }
public float rotatedY(float v,float angle) { return v*sin(angle); }
public float rotatedX(float x,float y,float angle) { return x*cos(angle) - y*sin(angle); }
public float rotatedY(float x,float y,float angle) { return x*sin(angle) + y*cos(angle); }

public float dot(float x1, float y1, float x2, float y2) { return x1*x2 + y1*y2; }

// generic linear interpolation
public int mix(int a,int b, float f) { return (int)(a+(b-a)*f); }
public double mix(double a, double b, double f) { return a+(b-a)*f; }

// blend 2 colours
public int blendC(int a, int b, float f) {
  return
    mix(a>>16&0xff,b>>16&0xff,f)<<16 |
    mix(a>>8&0xff,b>>8&0xff,f)<<8 |
    mix(a&0xff,b&0xff,f) ;
}
public int blendC0(int a, int b, float f) {
  return mix(a>>16,b>>16,f)<<16 | mix(a>>8&0xff,b>>8&0xff,f)<<8 | mix(a&0xff,b&0xff,f);
}

//--------------------------------------------------------------------------------
// Drawing
public void aapixel(float x, float y, int c, float a) {
  int xint = (int)x;
  int yint = (int)y;
  float fx = x - xint;
  float fy = y - yint;
  
  //pixels[xint+yint*width] = blendC(pixels[xint+yint*width], c, ((1-fx)*(1-fy))*a);
  
  // dub sez... blend with color of image
  pixels[xint+yint*width] = blendC(
    pixels[xint+yint*width],
    myFoodImg.pixels[xint+yint*width],
    ((1-fx)*(1-fy))*a);
  
  if(xint<width-1) pixels[xint+yint*width+1] = blendC(pixels[xint+yint*width+1], c, (fx*(1-fy))*a);
  if(yint<height-1) pixels[xint+yint*width+width] = blendC(pixels[xint+yint*width+width], c, ((1-fx)*fy)*a);
  if(xint<width-1 && yint<height-1) pixels[xint+yint*width+width+1] = blendC(pixels[xint+yint*width+width+1], c, (fx*fy)*a);
}

class Mycelium
{
  Tip[] growth = new Tip[1000];
  int n;
  
  PImage foodImg;
  
  Mycelium(PImage f)
  {
    foodImg = f;
  }
  
  public void display()
  {
    // dub sez... less food affinity
    //for(int i=n; --i>=0;) growth[i].react(0.125, 3, 0.15, 4);
    for(int i=n; --i>=0;) growth[i].react(0.125f, 3, 0.25f, 2);
    
    for(int i=n; --i>=0;) {
      growth[i].update();
      if(growth[i].x<0 || growth[i].x>width-1 || growth[i].y<0 || growth[i].y>height-1) kill(i);
      else growth[i].display();
    }
  }
  
  public void spore(float x, float y, int ns)
  {
    for(int i=ns; --i>=0;) {
      if(n == growth.length) kill((int)random(n));
      growth[n++] = new Tip(x,y,random(-2,2),random(-2,2));
    }
  }
  
  public void spore(double x, double y, double xv, double yv)
  {
    if(n == growth.length) kill((int)random(n));
    growth[n++] = new Tip(x,y,xv,yv);
  }
  
  public void kill(int i)
  {
    if(i < n-1) System.arraycopy(growth, i+1, growth, i, n-1-i);
    n--;
  }
  
  public float food(double x, double y)
  {
    // dub sez... constrain to size
    int maxx = constrain((int)x, 0, width-1);
    int maxy = constrain((int)y, 0, height-1);
    int c = foodImg.pixels[maxx+maxy*foodImg.width];
    // dub sez.. why 765?
    return (red(c)+blue(c)+green(c))/768.0f;
  }
  
  public DVector2 brightVector(double x, double y, int[] pix, int w, int h, int spread, int limit)
  {
    // Find the vector to the brightest area
    int intx = (int)x;
    int inty = (int)y;
    float br;
    float cbr = 0;  // Cumulative Brightness
    float brx = 0;
    float bry = 0;
    int maxx = constrain(intx+spread, 0, w-1);
    int maxy = constrain(inty+spread, 0, h-1);
    for(int i=constrain(intx-spread, 0, w-1); i <= maxx; i++) {
      for(int j=constrain(inty-spread, 0, h-1); j <= maxy; j++) {
        br = (red(pix[j*w+i])+green(pix[j*w+i])+blue(pix[j*w+i]))/768.0f;
        if(limit > 0 && sq((float)x-i)+sq((float)y-j) > limit*limit) { br = 0; /*print("-------- ");*/ }
        //else print(nf(sqrt(sq((float)x-i)+sq((float)y-j)),0,6)+" ");
        cbr += br;
        brx += i*br;
        bry += j*br;
      }
      //println("/");
    }
    
    if(cbr != 0) return new DVector2(brx/cbr-x, bry/cbr-y);
    else return new DVector2(0,0);
  }
  
  class Tip extends DParticle
  {
    double lastx, lasty;
    
    Tip(double ix, double iy, double ixv, double iyv)
    {
      super(ix,iy,ixv,iyv);
    }
    
    public void react(float selfam, int selfsp, float foodam, int foodsp)
    {
      DVector2 selfbr = brightVector(x,y, pixels,width,height, selfsp, selfsp);
      DVector2 foodbr = brightVector(x,y, foodImg.pixels,width,height, foodsp, foodsp);
      
      // Move away from self
      if(selfbr.x != 0 && selfbr.y != 0) {
        xv = mix(xv, -selfbr.x, selfam);
        yv = mix(yv, -selfbr.y, selfam);
      }
      // Move toward food
      if(foodbr.x != 0 && foodbr.y != 0) {
        xv = mix(xv, foodbr.x, foodam);
        yv = mix(yv, foodbr.y, foodam);
      }
    }
    
    public void update()
    {
      lastx = x; lasty = y;
      xv += random(-.1f, .1f);
      yv += random(-.1f, .1f);
      
      float myfood = food(x,y);
      
      // Approach a normalized velocity
      double mag = Math.sqrt(xv*xv + yv*yv);
      xv += ((xv/mag)*mix(0.25f,1,myfood)-xv)*0.5f;
      yv += ((yv/mag)*mix(0.25f,1,myfood)-yv)*0.5f;
      
      super.update();
      
      if((int)random(lerp(200,40,myfood))==0) spore(lastx,lasty,xv+random(-0.1f,0.1f),yv+random(-0.1f,0.1f));
    }
    
    public void display()
    {
      // dub sez... blend factor
      aapixel((float)x,(float)y,color(255,224,192),0.33f);
      //aapixel((float)x,(float)y,color(255,255,255),0.15);
      //aapixel((float)x,(float)y,color(255,255,255),0.25);
    }
  }
}
static public void main(String args[]) {   PApplet.main(new String[] { "Myzel" });}}