<?php # Bildersuche

require_once('template.inc.php');

session_name('SID');
session_start();
$SID = 'SID=' . session_id();
$theme = '';
$preset = '';
$presets = array('Shanghai', 'Echelon', 'pix');

$base = 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['SCRIPT_NAME']);
$feed = $base . '/feed.php';

# Formular-Variablen: obligatorische, ohne Zeilenschaltung
$obls = array('Thema');
$nbrs = array('Thema', 'Preset');

# Leerzeichen trimmen, Slashes entfernen
foreach ($_REQUEST as $key => $value) {
	if (get_magic_quotes_gpc())
		$_REQUEST[$key] = stripslashes(trim($value));
	else
		$_REQUEST[$key] = trim($value);
}

# Fehler im Formular?
$error = array();

# Zeilenschaltungen reklamieren
foreach ($nbrs as $nbr)
	if (isset($_REQUEST[$nbr])
		&& (strpos($_REQUEST[$nbr], "\n")
			|| strpos($_REQUEST[$nbr], "\r")))
		$error[] = 'Korrupt: ' . $nbr;

# Obligatorische verlangen
foreach ($obls as $obl)
	if (!isset($_REQUEST[$obl]) || empty($_REQUEST[$obl]))
		$error[] = 'Fehlt: ' . $obl;

# Extrahieren
if (isset($_REQUEST['Thema']))
	$theme = urlencode($_REQUEST['Thema']);
if (isset($_REQUEST['Preset']))
	$preset = urlencode($_REQUEST['Preset']);

function findfiles($theme, $start) {
	$query = 'http://images.google.com/images?q='
		. $theme
		. '&imgsz=xlarge&start='
		. $start;
	preg_match_all('/imgurl=(http:\/\/\S+?\.(jpg|jpeg|gif|png))\&/iU',
		file_get_contents($query), $matches);
	/*
	preg_match_all('/http\S+:","(\S+?\.(jpg|jpeg|gif|png))/iU',
		file_get_contents($query), $matches);
	*/
	return ($matches[1]);
}

if (!$error && $theme) {
	$files1 = $files2 = $files3 = array();
	$files1 = findfiles($theme, 0);
	if (count($files1) == 20)
		$files2 = findfiles($theme, 20);
	if (count($files2) == 20)
		$files3 = findfiles($theme, 40);
	$_SESSION['files'] = array_merge($files1, $files2, $files3);
	# dont reset counter
}

if (in_array($preset, $presets)) {
	# clear file list
	$_SESSION['files'] = array();
	$theme = $preset;
	# read dir
	$prefix = $base . '/' . $preset;
	$handle = opendir($preset);
	while (false != ( $file = readdir($handle))) {
		$path_parts = pathinfo($file);
		if (strtolower($path_parts['extension']) != 'jpg')
	                	continue;
		$_SESSION['files'][] = $prefix . '/' . $file;
	}
	# reset counter
	$_SESSION['count'] = 1;
	# clear error
	$error = array();
}

if (count($_SESSION['files']) < 5)
	$error[] = 'Zu wenige Bilder gefunden';

# Seite drucken
$page =& new Template('');

# Applet anzeigen
if (!$error && ($theme || $preset)) {
	$page->set('Thema', $theme);
	$page->set('SID', $SID);
	$page->set('URI', $feed);
	$page->set('files', $_SESSION['files']);
	echo $page->fetch('applet.tmpl.php');
}
# Eingabeformular drucken: Fehler
elseif ($theme) {
	$page->set('Thema', $theme);
	$page->set('error', implode(', ', $error));
	$page->set('Self', $_SERVER['PHP_SELF']);
	echo $page->fetch('form.tmpl.php');
}
# Eingabeformular drucken: leer
else {
	$page->set('Self', $_SERVER['PHP_SELF']);
	echo $page->fetch('form.tmpl.php');
}

?>
